/* $Id: fmalloc.c,v 1.5 1992/01/04 14:30:36 schrod Exp $
 *----------------------------------------------------------------------
 */


#include "mkind.h"

#define ALLOCSIZE 16384

/* fast memory allocation: like malloc, but faster, because we don't need to
   free anything... */
VOIDP fmalloc( n )
SIZE_T n;
{
   static VOIDP buffer;		/* next free address */
   static SIZE_T count = 0;	/* # bytes available in this block */
   register VOIDP p;
   
   if (n > count) {

#ifdef DEBUG
	totmem += ALLOCSIZE;
	(void)fprintf(stderr,"fmalloc(): malloc(%d)\ttotmem = %ld\n",
	    ALLOCSIZE,totmem);
#endif /* DEBUG */

      /* allocate a new chunk */
      if ((buffer = malloc( count = ALLOCSIZE )) == NULL) {
	 fprintf( stderr, "\nSorry, not enough core...abort.\n","");
	 exit(3);
      }
   }

   p = buffer;
   buffer = (VOIDP)((char *)buffer + n); /* no pointer arithmetic with void! */
   count -= n;

   return (p);
}


/*
 * $Log: fmalloc.c,v $
 * Revision 1.5  1992/01/04  14:30:36  schrod
 * Arithmetic is not defined on void pointers.
 *
 * Revision 1.4  1991/12/16  14:44:50  schrod
 * fmalloc() statt allocate()
 *
 * Revision 1.3  1991/12/10  20:22:32  schrod
 * Changed parameter type from 'unsigned' to 'SIZE_T'.
 *
 * Revision 1.2  1991/12/10  20:09:13  schrod
 * Debug output added
 *
 * Revision 1.1  1991/12/10  16:52:06  schrod
 * Initial revision
 *
 */
