/* starting time is 20:19:19 */
/* C code produced by gperf version 2.5 (GNU C++ version) */
/* Command-line: gperf -L C -t -p -k 1,6,7,11 -N is_style_spec -T hashst.gpf  */
/* $Id: hashst.c,v 1.2 1992/01/03 13:21:33 schrod Exp $
 *----------------------------------------------------------------------
 * Perfect hash-table for MakeIndex style specifiers.
 * This is an input file for the GNU gperf utility!
 *
 * Author: Gabor Herr
 *
 */

/*
 * $Log: hashst.c,v $
 * Revision 1.2  1992/01/03  13:21:33  schrod
 * Declared prototypes.
 *
 * Revision 1.1  1991/12/16  15:03:08  schrod
 * Initial revision
 *
 * Revision 1.1  1991/12/10  20:19:57  schrod
 * Initial revision
 *
 */

#include "mkind.h"
#include "scanst.h"

/* for the sake of MS C, which needs a prototype always */
static unsigned int hash ARGS((char *, unsigned int));

#define TOTAL_KEYWORDS 46
#define MIN_WORD_LENGTH 5
#define MAX_WORD_LENGTH 15
#define MIN_HASH_VALUE 5
#define MAX_HASH_VALUE 120
/* maximum key range = 116, duplicates = 0 */

static unsigned int
hash (str, len)
     register char *str;
     register int unsigned len;
{
  static unsigned char asso_values[] =
    {
     121, 121, 121, 121, 121, 121, 121, 121, 121, 121,
     121, 121, 121, 121, 121, 121, 121, 121, 121, 121,
     121, 121, 121, 121, 121, 121, 121, 121, 121, 121,
     121, 121, 121, 121, 121, 121, 121, 121, 121, 121,
     121, 121,  30, 121, 121, 121, 121, 121,  10,  20,
      25, 121, 121, 121, 121, 121, 121, 121, 121, 121,
     121, 121, 121, 121, 121, 121, 121, 121, 121, 121,
     121, 121, 121, 121, 121, 121, 121, 121, 121, 121,
     121, 121, 121, 121, 121, 121, 121, 121, 121, 121,
     121, 121, 121, 121, 121,   0, 121,   0,   0,  55,
       0,   0,   5,   0,  20,   0, 121,  55,  15,  25,
      50,  20,  30,  20,  40,   0,  15,   0, 121, 121,
      40, 121, 121, 121, 121, 121, 121, 121,
    };
  register int hval = len;

  switch (hval)
    {
      default:
      case 11:
        hval += asso_values[str[10]];
      case 10:
      case 9:
      case 8:
      case 7:
        hval += asso_values[str[6]];
      case 6:
        hval += asso_values[str[5]];
      case 5:
      case 4:
      case 3:
      case 2:
      case 1:
        hval += asso_values[str[0]];
    }
  return hval;
}

struct hashentry *
is_style_spec (str, len)
     register char *str;
     register unsigned int len;
{
  static struct hashentry wordlist[] =
    {
      {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"encap", 		ENCAP,		"%c",	&idx_encap,	NULL},
      {"escape", 		ESCAPE,		"%c",	&idx_escape,	NULL},
      {"include", 	INCLUDE_STY,	"%s",	NULL,		NULL},
      {"",}, {"",}, 
      {"group_skip", 	GROUP_SKIP,	"%s",	&group_skip,	&skiplen},
      {"",}, 
      {"encap_suffix", 	ENCAP_2,	"%s",	&encap_s,	NULL},
      {"",}, 
      {"setpage_prefix", 	SETPAGEOPEN,	"%s",	&setpage_open,	&setpagelen},
      {"",}, 
      {"item_0", 		ITEM_0,		"%s",	&item_r[0],	&ilen_r[0]},
      {"delim_0", 	DELIM_0,	"%s",	&delim_p[0],	NULL},
      {"",}, 
      {"setpage_suffix", 	SETPAGECLOSE,	"%s",	&setpage_close,	&setpagelen},
      {"level", 		LEVEL,		"%c",	&idx_level,	NULL},
      {"actual", 		ACTUAL,		"%c",	&idx_actual,	NULL},
      {"delim_t", 	DELIM_T,	"%s",	&delim_t,	NULL},
      {"",}, {"",}, 
      {"quote", 		QUOTE,		"%c",	&idx_quote,	NULL},
      {"item_1", 		ITEM_1,		"%s",	&item_r[1],	&ilen_r[1]},
      {"delim_1", 	DELIM_1,	"%s",	&delim_p[1],	NULL},
      {"indent_length", 	INDENT_LENGTH,	"%d",	&indent_length,	NULL},
      {"",}, 
      {"group_head", 	GROUP_HEAD,	"%d%s",	NULL,		NULL},
      {"item_2", 		ITEM_2,		"%s",	&item_r[2],	&ilen_r[2]},
      {"delim_2", 	DELIM_2,	"%s",	&delim_p[2],	NULL},
      {"",}, {"",}, {"",}, {"",}, 
      {"item_01", 	ITEM_01,	"%s",	&item_u[1],	&ilen_u[1]},
      {"arg_open", 	AOPEN,		"%c",	&idx_aopen,	NULL},
      {"",}, {"",}, 
      {"*merge_rule", 	R_MERGE_RULE,	"%r%r",	NULL,		NULL},
      {"encap_prefix", 	ENCAP_0,	"%s",	&encap_p,	NULL},
      {"",}, 
      {"arg_close", 	ACLOSE,		"%c",	&idx_aclose,	NULL},
      {"",}, {"",}, 
      {"delim_r", 	DELIM_R,	"%s",	&delim_r,	NULL},
      {"line_max", 	LINEMAX,	"%d",	&linemax,	NULL},
      {"sort_rule", 	SORT_RULE,	"%r%r",	NULL,		NULL},
      {"sort_group", 	SORT_GROUP,	"%s%d",	NULL,		NULL},
      {"encap_infix", 	ENCAP_1,	"%s",	&encap_i,	NULL},
      {"item_12", 	ITEM_12,	"%s",	&item_u[2],	&ilen_u[2]},
      {"preamble", 	PREAMBLE,	"%s",	&preamble,	&prelen},
      {"",}, {"",}, {"",}, 
      {"delim_n", 	DELIM_N,	"%s",	&delim_n,	NULL},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"postamble", 	POSTAMBLE,	"%s",	&postamble,	&postlen},
      {"",}, {"",}, 
      {"item_x1", 	ITEM_x1,	"%s",	&item_x[1],	&ilen_x[1]},
      {"",}, {"",}, 
      {"range_open", 	ROPEN,		"%c",	&idx_ropen,	NULL},
      {"",}, 
      {"item_x2", 	ITEM_x2,	"%s",	&item_x[2],	&ilen_x[2]},
      {"",}, {"",}, 
      {"merge_rule", 	MERGE_RULE,	"%r%r",	NULL,		NULL},
      {"",}, {"",}, {"",}, {"",}, 
      {"*sort_rule", 	R_SORT_RULE,	"%r%r",	NULL,		NULL},
      {"",}, 
      {"indent_space", 	INDENT_SPACE,	"%s",	&indent_space,	NULL},
      {"",}, 
      {"heading_prefix", 	HEADING_PRE,	"%s",	&heading_pre,	&headprelen},
      {"",}, {"",}, {"",}, {"",}, 
      {"heading_suffix", 	HEADING_SUF,	"%s",	&heading_suf,	&headsuflen},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"headings_flag", 	HEADINGS_FLAG,	"%d",	&headings_flag,	NULL},
      {"",}, {"",}, {"",}, 
      {"keyword", 	KEYWORD,	"%s",	&idx_keyword,	NULL},
      {"",}, {"",}, {"",}, 
      {"range_close", 	RCLOSE,		"%c",	&idx_rclose,	NULL},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"page_precedence", PRECEDENCE,	"%s",	NULL,		NULL},
      {"",}, {"",}, {"",}, {"",}, 
      {"page_compositor", COMPOSITOR,	"%s",	&page_comp,	NULL},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register char *s = wordlist[key].name;

          if (*s == *str && !strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}
/* ending time is 20:19:19 */
