/* $Id: regexp.h,v 1.2 1992/01/03 10:53:27 schrod Exp $
 *----------------------------------------------------------------------
 *
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */

/*
 * This header file, originally from Henry Spencer, was changed by
 * Joachim Schrod <schrod@iti.informatik.th-darmstadt.de>.
 *    It may now be processed by an ANSI C compliant compiler and it may
 * be read in more than once.
 *
 * CAVEAT: If the macro ARGS is defined, it is assumed that this macro may
 * be used for the well known prototype-hiding trick. This is dirty and
 * I know it, but it works (usually). A similar comment holds for the macro
 * const to be used with non-ANSI compliant compilers.
 *
 * In fact, the package should be rewritten in ANSI C and should use
 * a (more or less `standard') configuration file which sets up respective
 * definitions. ansidecl.h from the FSF comes to mind, but it would change
 * the copyright clause in an unwished way. So, some day I'll polish my
 * portable.h and will add it to this package...
 *
 * [history at end]
 */

#ifndef _V8_REGEXP_H_	/* don't use _REGEXP_H_ as defining id, a conflict */
#define _V8_REGEXP_H_	/* with other <regexp.h>'s is wanted!!		   */

#define NSUBEXP  10
typedef struct regexp {
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} regexp;

#ifndef ARGS
#   ifdef __STDC__
#   	define ARGS(arg_list)	arg_list
#   else
#   	define ARGS(arg_list)	()
#   endif
#endif

#if !defined(__STDC__)  &&  !defined(const)
#   define const	/* support for a missing ANSI keyword */
#endif

extern regexp *regcomp ARGS((char* expression));
extern int regexec ARGS((regexp *prog, char *string));
extern void regsub ARGS((regexp *prog, char *source, char *dest));
extern void regerror ARGS((char *msg));


#endif /* _V8_REGEXP_H_ */


/*
 * $Log: regexp.h,v $
 * Revision 1.2  1992/01/03  10:53:27  schrod
 * May now be processed correctly by an ANSI C compiler and may be read
 * in more than once.
 *
 */
