#include "utils.h"

char *filename = NULL;

size_t sfwrite(void *ptr, size_t size, size_t nmemb, FILE *stream)
{
    if (fwrite(ptr, size, nmemb, stream) != nmemb)
        FAIL("fwrite() failed: %s" AND SYS_ERR);
    return nmemb;
}

long sftell( FILE *stream)
{
    long i = ftell(stream);
    if (i < 0)
        FAIL("ftell() failed: %s" AND SYS_ERR);
    return i;
}

int sfseek(FILE *stream, long offset, int whence)
{
    if (fseek(stream, offset, whence) < 0)
        FAIL("fseek() failed: %s" AND SYS_ERR);
    return 0;
}

int sfflush(FILE *s)
{
    if (fflush(s) != 0)
        FAIL("fflush() failed: %s" AND SYS_ERR);
    return 0;
}

void *smalloc(long size)
{
    void *p = malloc(size);
    if (p == NULL)
        FAIL("malloc() failed: %s" AND SYS_ERR);
    return p;
}

char *getstr(char *buf, int s)
{
    int i;
    char *p = buf;
    for (i = strstart[s]; i < strstart[s + 1]; i++)
        *p++ = strpool[i];
    *p = 0;
}

char *getstrpool(int s)
{
    static char laststr[81];
    char *p = laststr;
    int i, l = strstart[s + 1] - strstart[s];
    if (l > 80)
        l = 80;
    for (i = 0; i < l; i++)
        *p++ = strpool[i + strstart[s]];
    *p = 0;
    return laststr;
}

int printobjlist(int i)
{
    int p;
    for (p = headtab[i]; p != 0; p = objtab[p].objentryw0.hh.v.RH)
        printf("objnum = %d\tinfo = %d\tname = %s\n", p,
            objtab[p].objentryw0.hh.v.LH,
            objtab[p].objentryw0.hh.v.LH != 0 ? "noname" :
            getstrpool(objtab[p].objentryw1.hh.v.RH));
    return 0;
}

