# common.make -- used by all Makefiles.

!include "nt.make"

# Kpathsea needs this for compiling, programs need it for linking.
LIBTOOL = $(kpathsea_srcdir_parent)/klibtool

# You can change [X]CPPFLAGS, [X]CFLAGS, or [X]DEFS, but
# please don't change ALL_CPPFLAGS or ALL_CFLAGS.
# prog_cflags is set by subdirectories of web2c.
XDEFS = $(cvars)
ALL_CPPFLAGS = $(DEFS) -I. -I$(srcdir) $(prog_cflags) \
  -I$(kpathsea_parent) -I$(kpathsea_srcdir_parent) $(CPPFLAGS)
ALL_CFLAGS = $(ALL_CPPFLAGS) $(CFLAGS) -c
compile = $(CC) $(ALL_CFLAGS)

.SUFFIXES: .c .obj # in case the suffix list has been cleared, e.g., by web2c
.c.obj:
	$(compile) $<

# Installation.
INSTALL = copy
INSTALL_PROGRAM = copy
INSTALL_SCRIPT = $(INSTALL_PROGRAM)
INSTALL_DATA = copy
INSTALL_LIBTOOL_LIBS = INSTALL_DATA='$(INSTALL_DATA)' $(LIBTOOL) install-lib
INSTALL_LIBTOOL_PROG = INSTALL_PROGRAM='$(INSTALL_PROGRAM)' $(LIBTOOL) install-prog

# We use these for many things.
kpathsea_parent = ..
kpathsea_dir = $(kpathsea_parent)\kpathsea
kpathsea_srcdir_parent = $(top_srcdir)
kpathsea_srcdir = $(kpathsea_srcdir_parent)\kpathsea

# This is all so we can get the right name for the kpathsea library so
# we can depend on it.
staticlibname = kpathsea.lib
sharedlibname = kpathsea.dll
staticlib = $(kpathsea_srcdir)\$(staticlibname)
sharedlib = $(kpathsea_srcdir)\$(sharedlibname)
!IFDEF KPATHSEA_DLL
kpathsea = $(sharedlib)
!ELSE
kpathsea = $(staticlib)
!ENDIF

# End of common.make.

# Local Variables:
# mode: Makefile
# End:
