# config.make -- rules to remake the Makefile, c-auto.h, etc.

C_AUTO_H_DIRS = dvipsk dviljk kpathsea web2c
MAKEFILE_DIRS = $(C_AUTO_H_DIRS) web2c\lib web2c\mpware web2c\web2c

config.status: $(win32)/c-auto.h $(win32)/Makefile.win32 \
	$(win32)/Makefile.dvipsk $(win32)/Makefile.dviljk \
	$(win32)/Makefile.kpathsea $(win32)/Makefile.makeindex \
	$(win32)/Makefile.root \
	$(win32)/Makefile.web2c $(win32)/Makefile.web2c.doc \
	$(win32)/Makefile.web2c.lib \
	$(win32)/Makefile.web2c.mpware $(win32)/Makefile.web2c.libpdf \
	$(win32)/Makefile.web2c.web2c $(win32)/Makefile.web2c.window \
	$(win32)/Makefile.xdvik
	$(TOUCH) $(win32)\config.status
	$(CP) $(win32)\c-auto.h $(srcdir)\dvipsk\c-auto.h
	$(CP) $(win32)\c-auto.h $(srcdir)\dviljk\c-auto.h
	$(CP) $(win32)\c-auto.h $(srcdir)\kpathsea\c-auto.h
	$(CP) $(win32)\c-auto.h $(srcdir)\makeindex\c-auto.h
	$(CP) $(win32)\c-auto.h $(srcdir)\web2c\c-auto.h
	$(CP) $(win32)\c-auto.h $(srcdir)\xdvik\c-auto.h
	$(CP) $(win32)\Makefile.win32 $(srcdir)\win32\Makefile
	$(CP) $(win32)\Makefile.dvipsk $(srcdir)\dvipsk\Makefile
	$(CP) $(win32)\Makefile.dviljk $(srcdir)\dviljk\Makefile
	$(CP) $(win32)\Makefile.kpathsea $(srcdir)\kpathsea\Makefile
	$(CP) $(win32)\Makefile.makeindex $(srcdir)\makeindex\Makefile
	$(CP) $(win32)\Makefile.root $(srcdir)\Makefile
	$(CP) $(win32)\Makefile.web2c $(srcdir)\web2c\Makefile
	$(CP) $(win32)\Makefile.web2c.doc $(srcdir)\web2c\doc\Makefile
	$(CP) $(win32)\Makefile.web2c.lib $(srcdir)\web2c\lib\Makefile
	$(CP) $(win32)\Makefile.web2c.mpware $(srcdir)\web2c\mpware\Makefile
	$(CP) $(win32)\Makefile.web2c.libpdf $(srcdir)\web2c\libpdf\Makefile
	$(CP) $(win32)\Makefile.web2c.libpdf.libpng $(srcdir)\web2c\libpdf\libpng\Makefile
	$(CP) $(win32)\Makefile.web2c.libpdf.zlib $(srcdir)\web2c\libpdf\zlib\Makefile
	$(CP) $(win32)\Makefile.web2c.web2c $(srcdir)\web2c\web2c\Makefile
	$(CP) $(win32)\Makefile.web2c.window $(srcdir)\web2c\window\Makefile
	$(CP) $(win32)\Makefile.xdvik $(srcdir)\xdvik\Makefile
#	$(CP) $(win32)\Makefile.xdvik-win32 $(srcdir)\xdvik-win32\Makefile

# What a pity : it can't work like this. How to substitute / for .
# in the last %%d ? 
#import_c_auto_h:
#	for %%d in ($(MAKEFILE_DIRS)) do \
#	if exist $(srcdir)\%%d\c-auto.h $(CP) $(srcdir)\%%d\c-auto.h $(win32)\c-auto.h.%%d
#
#import_makefile:
#	for %%d in ($(MAKEFILE_DIRS)) do \
#	if exist $(srcdir)\%%d\Makefile $(CP) $(srcdir)\%%d\Makefile $(win32)\Makefile.%%d
#

import-config:
	$(CP) $(srcdir)\Makefile $(win32)\Makefile.root
	$(CP) $(srcdir)\win32\Makefile $(win32)\Makefile.win32
	$(CP) $(srcdir)\dvipsk\Makefile $(win32)\Makefile.dvipsk
	$(CP) $(srcdir)\dviljk\Makefile $(win32)\Makefile.dviljk
	$(CP) $(srcdir)\kpathsea\Makefile $(win32)\Makefile.kpathsea
	$(CP) $(srcdir)\makeindex\Makefile $(win32)\Makefile.makeindex
	$(CP) $(srcdir)\web2c\Makefile $(win32)\Makefile.web2c
	$(CP) $(srcdir)\web2c\doc\Makefile $(win32)\Makefile.web2c.doc
	$(CP) $(srcdir)\web2c\lib\Makefile $(win32)\Makefile.web2c.lib
	$(CP) $(srcdir)\web2c\mpware\Makefile $(win32)\Makefile.web2c.mpware
	$(CP) $(srcdir)\web2c\libpdf\Makefile $(win32)\Makefile.web2c.libpdf
	$(CP) $(srcdir)\web2c\web2c\Makefile $(win32)\Makefile.web2c.web2c
	$(CP) $(srcdir)\web2c\window\Makefile $(win32)\Makefile.web2c.window
	$(CP) $(srcdir)\xdvik\Makefile $(win32)\Makefile.xdvik
#	$(CP) $(srcdir)\xdvik-win32\Makefile $(win32)\Makefile.xdvik-win32

diff-config:
	-$(DIFF) $(srcdir)\Makefile $(win32)\Makefile.root
	-$(DIFF) $(srcdir)\win32\Makefile $(win32)\Makefile.win32
	-$(DIFF) $(srcdir)\dvipsk\Makefile $(win32)\Makefile.dvipsk
	-$(DIFF) $(srcdir)\dviljk\Makefile $(win32)\Makefile.dviljk
	-$(DIFF) $(srcdir)\kpathsea\Makefile $(win32)\Makefile.kpathsea
	-$(DIFF) $(srcdir)\makeindex\Makefile $(win32)\Makefile.makeindex
	-$(DIFF) $(srcdir)\web2c\Makefile $(win32)\Makefile.web2c
	-$(DIFF) $(srcdir)\web2c\doc\Makefile $(win32)\Makefile.web2c.doc
	-$(DIFF) $(srcdir)\web2c\lib\Makefile $(win32)\Makefile.web2c.lib
	-$(DIFF) $(srcdir)\web2c\mpware\Makefile $(win32)\Makefile.web2c.mpware
	-$(DIFF) $(srcdir)\web2c\libpdf\Makefile $(win32)\Makefile.web2c.libpdf
	-$(DIFF) $(srcdir)\web2c\libpdf\libpng\Makefile $(win32)\Makefile.web2c.libpdf.libpng
	-$(DIFF) $(srcdir)\web2c\libpdf\zlib\Makefile $(win32)\Makefile.web2c.libpdf.zlib
	-$(DIFF) $(srcdir)\web2c\web2c\Makefile $(win32)\Makefile.web2c.web2c
	-$(DIFF) $(srcdir)\web2c\window\Makefile $(win32)\Makefile.web2c.window
	-$(DIFF) $(srcdir)\xdvik\Makefile $(win32)\Makefile.xdvik

#
# distrib files
#

#Makefile: $(srcdir)/Makefile.in config.status $(top_srcdir)/../make/*.make
#	$(SHELL) config.status

# This rule isn't used for the top-level Makefile, but it doesn't hurt.
# We don't depend on config.status because configure always rewrites
# config.status, even when it doesn't change. Thus it might be newer
# than c-auto.h when we don't need to remake the latter.
#c-auto.h: stamp-auto
#stamp-auto: $(srcdir)/c-auto.h.in
#	$(SHELL) config.status
#	date >$(srcdir)/stamp-auto

##ifdef HOSTNAME
### autoheader reads acconfig.h (and c-auto.h.top) automatically.
##$(srcdir)/c-auto.h.in: $(srcdir)/stamp-auto.in
##$(srcdir)/stamp-auto.in: $(configure_in) $(autoheader) \
##  $(kpathsea_srcdir)/acconfig.h
##	cd $(srcdir) && autoheader --localdir=$(kpathsea_srcdir)
##	date >$(srcdir)/stamp-auto.in
##endif

$(srcdir)\Makefile:	$(win32)\Makefile.root
	$(CP) $** $@
$(srcdir)\win32\Makefile:	$(win32)\Makefile.win32
	$(CP) $** $@
$(srcdir)\dvipsk\Makefile:	$(win32)\Makefile.dvipsk
	$(CP) $** $@
$(srcdir)\dviljk\Makefile:	$(win32)\Makefile.dviljk
	$(CP) $** $@
$(srcdir)\kpathsea\Makefile:	$(win32)\Makefile.kpathsea
	$(CP) $** $@
$(srcdir)\makeindex\Makefile:	$(win32)\Makefile.makeindex
	$(CP) $** $@
$(srcdir)\web2c\Makefile:	$(win32)\Makefile.web2c
	$(CP) $** $@
$(srcdir)\web2c\doc\Makefile:	$(win32)\Makefile.web2c.doc
	$(CP) $** $@
$(srcdir)\web2c\lib\Makefile:	$(win32)\Makefile.web2c.lib
	$(CP) $** $@
$(srcdir)\web2c\mpware\Makefile:	$(win32)\Makefile.web2c.mpware
	$(CP) $** $@
$(srcdir)\web2c\libpdf\Makefile:	$(win32)\Makefile.web2c.libpdf
	$(CP) $** $@
$(srcdir)\web2c\libpdf\libpng\Makefile:	$(win32)\Makefile.web2c.libpdf.libpng
	$(CP) $** $@
$(srcdir)\web2c\libpdf\zlib\Makefile:	$(win32)\Makefile.web2c.libpdf.zlib
	$(CP) $** $@
$(srcdir)\web2c\web2c\Makefile:	$(win32)\Makefile.web2c.web2c
	$(CP) $** $@
$(srcdir)\web2c\window\Makefile:	$(win32)\Makefile.web2c.window
	$(CP) $** $@
$(srcdir)\xdvik\Makefile:	$(win32)\Makefile.xdvik
	$(CP) $** $@
$(srcdir)\dvipsk\c-auto.h:	$(win32)\c-auto.h
	$(CP) $** $@
$(srcdir)\dviljk\c-auto.h:	$(win32)\c-auto.h
	$(CP) $** $@
$(srcdir)\kpathsea\c-auto.h:	$(win32)\c-auto.h
	$(CP) $** $@
$(srcdir)\web2c\c-auto.h:	$(win32)\c-auto.h
	$(CP) $** $@
$(srcdir)\xdvik\c-auto.h:	$(win32)\c-auto.h
	$(CP) $** $@

$(win32)\texmflib.lst: $(top_srcdir)\..\texmflib-7.2.tar.gz
	gzip -dc $(top_srcdir)\..\texmflib-7.2.tar.gz \
	| tar tf - \
	| $(SED) "s@^@share/@" > $(win32)\texmflib.lst
	echo share/texmf/fonts/pk>>$(win32)\texmflib.lst
	echo share/texmf_fr>>$(win32)\texmflib.lst
	echo share/texmf_teTeX>>$(win32)\texmflib.lst
	echo share/texmf_misc>>$(win32)\texmflib.lst
	echo share/texmf_ps>>$(win32)\texmflib.lst
	echo share/texmf_sauter>>$(win32)\texmflib.lst
	echo share/texmf_latex>>$(win32)\texmflib.lst
	echo share/texmf_pdftex>>$(win32)\texmflib.lst
	echo l2h>>$(win32)\texmflib.lst

bindist: $(top_srcdir)\..\$(version).$(minver)-win32.tar.gz

$(top_srcdir)\..\$(version).$(minver)-win32.tar.gz: $(win32)\texmflib.lst
	tar cvXf $(win32)\texmflib.lst $(top_srcdir)\..\$(version).$(minver)-win32.tar -C $(prefix) .
	gzip -9  $(top_srcdir)\..\$(version).$(minver)-win32.tar

srcdist: $(top_srcdir)\..\$(version).$(minver)-win32-src.tar.gz

$(top_srcdir)\..\$(version).$(minver)-win32-src.tar.gz:
	$(MAKE) import-config
	$(MAKE) clean
	$(MAKE) extraclean
	$(MAKE) mostlyclean
	tar -cv --exclude xdvik-win32 --exclude xdviw32 -f $(top_srcdir)\..\$(version).$(minver)-win32-src.tar -C $(top_srcdir) ./
	gzip -9  $(top_srcdir)\..\$(version).$(minver)-win32-src.tar

distrib: $(top_srcdir)\..\$(version).$(minver)-win32.tar.gz\
	$(top_srcdir)\..\$(version).$(minver)-win32-src.tar.gz\
	$(top_srcdir)\..\texmflib-fr.tar.gz\
	$(top_srcdir)\..\texmflib-ps.tar.gz\
	$(top_srcdir)\..\texmflib-misc.tar.gz\
	$(top_srcdir)\..\texmflib-pdftex.tar.gz\
	$(top_srcdir)\..\texmflib-sauter.tar.gz

$(top_srcdir)\..\texmflib-fr.tar.gz:
	tar cvf $(top_srcdir)\..\texmflib-fr.tar -C $(prefix) ./share/texmf_fr
	gzip -9 $(top_srcdir)\..\texmflib-fr.tar

$(top_srcdir)\..\texmflib-ps.tar.gz:
	tar cvf $(top_srcdir)\..\texmflib-ps.tar -C $(prefix) ./share/texmf_ps
	gzip -9 $(top_srcdir)\..\texmflib-ps.tar

$(top_srcdir)\..\texmflib-misc.tar.gz:
	tar cvf $(top_srcdir)\..\texmflib-misc.tar -C $(prefix) ./share/texmf_misc
	gzip -9 $(top_srcdir)\..\texmflib-misc.tar

$(top_srcdir)\..\texmflib-sauter.tar.gz:
	tar cvf $(top_srcdir)\..\texmflib-sauter.tar -C $(prefix) ./share/texmf_sauter
	gzip -9 $(top_srcdir)\..\texmflib-sauter.tar

$(top_srcdir)\..\texmflib-pdftex.tar.gz:
	tar cvf $(top_srcdir)\..\texmflib-pdftex.tar -C $(prefix) ./share/texmf_pdftex
	gzip -9 $(top_srcdir)\..\texmflib-pdftex.tar

# End of config.make.

# Local Variables:
# mode: Makefile
# End:
