# APPVER = 4.0
# TARGETOS = BOTH
#PROFILE = 1
#NODEBUG = 1
#!include <win32.mak>
CONFIG_MT=1
MSVC_DLL=1
KPATHSEA_DLL=1
PNG_DLL=1
ZLIB_DLL=1
majver=70
minver=3

# Ensure that if MSVCRT is choosen, MT is defined.
!IFDEF MSVC_DLL
!IFNDEF CONFIG_MT
CONFIG_MT=1
!ENDIF
!ENDIF

# Configurable section

# Where to find gnu tools ?
# tr, sed, grep, cat are needed

gnutools = g:\Local
gnubin = $(gnutools)\bin
gnuinc = $(gnutools)\include
gnulib = $(gnutools)\lib

SHELL=	cmd /x
TR=	$(gnubin)\tr.exe
SED=	$(gnubin)\sed.exe
GREP=	$(gnubin)\grep.exe
DIFF=	$(gnubin)\diff.exe -u
ECHO=	echo
CP=	copy
TOUCH=	copy nul
RM=	del /F /Q
MV=	copy

# Needed for tex2pdf
pnglibs = $(gnulib)\libpng.lib $(gnulib)\libz.lib

# Where is the kpathsea directory ?
top_srcdir = g:\src\TeX\texk-7.0
srcdir=	.
win32=	$(top_srcdir)\win32
version= 7.0

# Need to find kpathsea.dll if it is not already installed
PATH = $(top_srcdir)\kpathsea;$(PATH)

# Where to put other tools (png stuff)
toolsprefix = g:\Local

# Your compiler. All this stuff is for MSVC++ 4.x
CC = cl

# Compilation flags. Currently, TeX doesn't allow full optimization.
!IFDEF NODEBUG
optflags = -O2x -G5r -Gy
# opttexflags = -Oityb2 -G5r
# opttexflags = -O2x -G5r -Gy
lmap = 
!ELSE
!IFDEF PROFILE
optflags = -O2x -G5r -Gh -Fm
opttexflags = -O2ityb2 -G5r -Gh -Fm
lmap = /MAP
!ELSE
optflags = -Od -Zi -G5r
opttexflags = -Od -Zi -G5r
lmap =
!ENDIF
!ENDIF

# For Windows applications that use the C Run-Time libraries
# Use the DLL MultiThread C Library
cvars      = -DWIN32 -D_WIN32 -DWIN32_LEAN_AND_MEAN
!IFDEF CONFIG_MT
cvars      = $(cvars) -D_MT
!ENDIF
!IFDEF MSVC_DLL
cvars   = $(cvars) -D_DLL
!ENDIF

CFLAGS = -c -nologo $(optflags) $(XCFLAGS)
CPPFLAGS = $(XCPPFLAGS)
DEFS = $(XDEFS)

!IFDEF NODEBUG
ldebug = /RELEASE /OPT:REF /VERSION:$(majver),$(minver)
!ELSE
!IFDEF PROFILE
ldebug = -debug:mapped,partial -debugtype:coff
!ELSE
ldebug = -debug:full -debugtype:cv
!ENDIF
!ENDIF
lflags =  /NODEFAULTLIB /INCREMENTAL:NO /PDB:NONE /NOLOGO \
	-align:0x1000 $(ldebug)
conlflags = $(lflags) -subsystem:console -entry:mainCRTStartup
dlllflags = $(lflags) -entry:_DllMainCRTStartup@12 -dll

!IFDEF PROFILE
optlibs =  cap.lib
!ELSE
optlibs =
!ENDIF

!IFDEF MSVC_DLL
libc = msvcrt.lib oldnames.lib  kernel32.lib $(optlibs) advapi32.lib
!ELSE
!IFDEF CONFIG_MT
libc = libcmt.lib oldnames.lib  kernel32.lib $(optlibs) advapi32.lib
!ELSE
libc = libc.lib oldnames.lib kernel32.lib $(optlibs) advapi32.lib
!ENDIF
!ENDIF

# Local Variables:
# mode: Makefile
# End.